-- $Name: Три сферы$
-- $Version: 0.1$
-- $Autor: kerbal$
-- $Info: Порт демки про сферы со спектрума на стеад3"$

require "sprite"
require "timer"

local ctx =  pixels.new(288,224,2)
local spr = sprite.new(576,448)

local x = 0
local y = 0
local z = 0
local dx = 0
local dy = 0
local dz = 0
local dd

local c = {}
local r = {}
local q = {}

local objects = {
	{x = -0.3, y = -0.8, z = 3.0, r = 0.6,
	dir_x = -1, dir_y = -1, dir_z = -1, speed = 0.03},
				
	{x = 0.9, y = -1.1, z = 2.0, r = 0.2,
	dir_x = 1, dir_y = 1, dir_z = 1, speed = 0.03},
	
	{x = 0., y = -0.1, z = 1.5, r = 0.3,
	dir_x = 1, dir_y = 1, dir_z = -1, speed = 0.06},
}

local up_border = 0.2
local down_border = -3.0
local left_border = -2.0
local right_border = 2.0
local front_border = 10.0
local back_border = 1.0

local function ZxPlot (x, y) 
	ctx:pixel(x + 16, 224 - (y + 16), 255, 255, 0);
end

local function DrawScene ()

	local function gos_u (i,j) 
		while true do
			local n = (y >= 0 or dy <= 0) and -1 or 0
			local s = 0;
			if n == 0 then
				s = -y / dy
			end
			for k = 1, #objects do
				local px = c[k][1] - x
				local py = c[k][2] - y
				local pz = c[k][3] - z
				local pp = px * px + py * py + pz * pz 
				local sc = px * dx + py * dy + pz * dz; 
				if sc > 0 then
					local bb = sc * sc / dd
					local aa = q[k] - pp + bb
					if aa > 0 then
						sc = (bb ^ 0.5 - aa ^ 0.5) / dd ^ 0.5;
						if sc < s or n < 0 then
							n = k
							s = sc
						end
					end 
				end
			end
			if n < 0 then
				return;
			end
			dx = dx * s;
			dy = dy * s;
			dz = dz * s;
			dd = dd * s * s;
			x = x + dx;
			y = y + dy;
			z = z + dz;
			if n == 0 then
				for k = 1, #objects do
					local u = c[k][1] - x;
					local v = c[k][3] - z;
					if u * u + v * v <= q[k] then
						return;
					end
				end
				if ((x - math.floor(x) > 0.5) ~= (z - math.floor(z) > 0.5)) then
					ZxPlot(j, i);
				end
				return;
			end
			local nx = x - c[n][1];
			local ny = y - c[n][2];
			local nz = z - c[n][3]; 
			local nn = nx * nx + ny * ny + nz * nz; 
			local l = 2 * (dx * nx + dy * ny + dz * nz) / nn; 
			dx = dx - nx * l;
			dy = dy - ny * l;
			dz = dz - nz * l;
		end
	end

	ctx:fill(0, 0, 288, 224, 0, 0, 0);
	
	c = {};
	r = {};
	q = {};
	for k = 1, #objects do
		c[k] = {};
		c[k][1] = objects[k]["x"];
		c[k][2] = objects[k]["y"];
		c[k][3] = objects[k]["z"];
		local t = objects[k]["r"];
		r[k] = t;
		q[k] = t * t;
	end
	for i = 0, 175 do
		for j = 0, 255 do
			x = 0.3;
			y = -0.5;
			z = 0;
			dx = j - 128;
			dy = 88 - i;
			dz = 300;
			dd = dx * dx + dy * dy + dz * dz;
			gos_u(i,j);
		end
	end
	
end

function init()
	timer:set(50)
end

room{
	nam = "main",
	disp = "Главная комната",
	pic = function()
		return spr;
	end,
	timer = function(s)
		for i = 1, #objects do
			if objects[i]["x"] < left_border + objects[i]["r"] or objects[i]["x"] > right_border - objects[i]["r"] then
				objects[i]["dir_x"] = objects[i]["dir_x"] * -1
			end
			if objects[i]["y"] < down_border + objects[i]["r"] or objects[i]["y"] > up_border - objects[i]["r"] then
				objects[i]["dir_y"] = objects[i]["dir_y"] * -1
			end
			if objects[i]["z"] < back_border + objects[i]["r"] or objects[i]["z"] > front_border - objects[i]["r"] then
				objects[i]["dir_z"] = objects[i]["dir_z"] * -1
			end
		end
	
		for i = 1, #objects do
			objects[i]["x"] = objects[i]["x"] + objects[i]["speed"] * objects[i]["dir_x"]
			objects[i]["y"] = objects[i]["y"] + objects[i]["speed"] * objects[i]["dir_y"]
			objects[i]["z"] = objects[i]["z"] + objects[i]["speed"] * objects[i]["dir_z"]
		end
		DrawScene();
		ctx:copy_spr(spr)
		s:pic()
		return false
	end,
	way = {"main"},
}
